/*****************************************************************
* C VDI EXAMPLE PROGRAM
*
* DEVELOPED WITH LASER C
* COPYRIGHT 1992 BY CLAYTON WALNUM
*****************************************************************/

#include <osbind.h>
#include <gemdefs.h>

#define BLACK 1
#define RED 2
#define GREEN 3
#define HOLLOW 0
#define SOLID 1
#define HAND 3
#define NORMAL 0
#define REPLACE 3
#define TRUE 1
#define FALSE 0
#define LEFT 1
#define RIGHT 2

int work_in[11], work_out[57], contrl[12],
    intin[128], ptsin[128], intout[128], ptsout[128];

int handle, cellw, cellh, boxw, boxh;
int res, h_factor, v_factor, t_factor, dummy;

/* Icon data. */

int icon[]={
0x0000,0x0000,0xFFFF,0x0000,0x7FFE,0x7FFE,0x8181,0x0180,
0x7FFE,0x7E7E,0x8241,0x0240,0x7FFE,0x7C3E,0x8421,0x0420,
0x7FFE,0x781E,0x8811,0x0810,0x7FFE,0x700E,0x9009,0x1008,
0x7FFE,0x6006,0xA005,0x2004,0x7FFE,0x4002,0xC003,0x4002,
0x7FFE,0x4002,0xC003,0x4002,0x7FFE,0x781E,0xF81F,0x781E,
0x7FFE,0x781E,0x8811,0x0810,0x7FFE,0x781E,0x8811,0x0810,
0x7FFE,0x781E,0x8811,0x0810,0x7FFE,0x781E,0x8811,0x0810,
0x7FFE,0x781E,0x8811,0x0810,0x7FFE,0x781E,0x8811,0x0810,
0x7FFE,0x7FFE,0x8FF1,0x0FF0,0x0000,0x0000,0xFFFF,0x0000
};

int icn_w = 16,  /* Width of icon.    */
    icn_h = 18;  /* Height of icon.   */

main()
{
  appl_init();
  open_vwork();
  v_hide_c(handle);
  do_pline();
  do_roundrec();
  do_pmarker();
  do_arc();
  do_fills();
  do_text();
  v_show_c(handle);
  do_raster();
  v_clsvwk(handle);
  appl_exit();
}

/*******************************************************
* Demonstrate Polylines
*******************************************************/
do_pline()
{
  int pxy[4];
  int color, end, type, width;

  pxy[0] = 30;   pxy[1] = 20;        /* Polyline starting coords   */
  pxy[2] = 280;  pxy[3] = 20;
  end = 0; width = 1;                /* Starting end style & width */
  v_clrwk(handle);
  for (color=1; color<5; ++color) {
    vsl_color(handle,color);
    vsl_ends(handle,end,end);
    vsl_width(handle,width);
    v_pline(handle,2,pxy);
    pxy[1] += 10;  pxy[3] += 10;     /* Change polyline coords    */
    end += 1; width += 2;            /* Change end style & width  */
  }
  vsl_width(handle,1);
  vsl_ends(handle,0,0);
  vsl_color(handle,1);
  for (type=1; type<7; ++type) {
    vsl_type(handle,type);
    pxy[1] += 10; pxy[3] += 10;
    v_pline(handle,2,pxy);
  }
  Cconin();
}

/*******************************************************
* Demonstrate Rounded Rectangles
*******************************************************/
do_roundrec()
{
  int pxy[4];
  int color, width;

  pxy[0] = 10;   pxy[1] = 10;        /* Rectangle starting coords  */
  pxy[2] = 300;  pxy[3] = 190;
  width = 1;                         /* Starting line width        */
  v_clrwk(handle);
  vsl_type(handle,1);
  for (color=1; color<7; ++color) {
    vsl_width(handle,width);
    vsl_color(handle,color);
    v_rbox(handle,pxy);
    width += 2;                      /* Calc next line width       */
    pxy[0] += 20;  pxy[1] += 20;     /* Calc new rectangle coords  */
    pxy[2] -= 10;  pxy[3] -= 10;
  }
  Cconin();
}

/*******************************************************
* Demonstrate Polymarkers
*******************************************************/
do_pmarker()
{
  int color, height, type;
  int pxy[2];

  v_clrwk(handle);
  pxy[1] = 10;
  for (type=1; type<7; ++type) {
    vsm_type(handle,type);
    height = 2;  pxy[0] = 10;
    for (color=1; color<6; ++color) {
      vsm_color(handle,color);
      vsm_height(handle,height);
      v_pmarker(handle,1,pxy);
      height += 16;  pxy[0] += 60;
    }
    pxy[1] += 35;
  }
  Cconin();
}
    
/*******************************************************
* Demonstrate Arcs
*******************************************************/
do_arc()
{
  int color, radius, bang, eang;

  v_clrwk(handle);
  vsl_width(handle,3);
  bang = 900; eang = 0; radius = 10;
  for (color=1; color<6; ++color) {
    vsl_color(handle,color);
    v_arc(handle,150,100,radius,bang,eang);
    bang += 60; eang -= 60; radius += 20;
  }
  Cconin();
}

/*******************************************************
* Demonstrate Fills
*******************************************************/
do_fills()
{
  int pxy[4], style, i, num, x;

  pxy[0] = 50; pxy[1] = 30;
  pxy[2] = 250; pxy[3] = 170; num = 25;
  for (i=2; i<4; ++i) {
    vsf_color(handle,i);
    vsf_interior(handle,i);
    for (style=1; style<num; ++style) {
      vsf_style(handle,style);
      v_clrwk(handle);
      v_bar(handle,pxy);
      for (x=0; x<32000; ++x);
    }
    num = 13;
  }
  Cconin();
}

/*******************************************************
* Demonstrate Graphic Text
*******************************************************/
do_text()
{
   init();
   do_effects();
   Cconin();
   do_rotate();
   Cconin();
}

/*******************************************************
* Text Effects
*******************************************************/
do_effects()
{
  int x, y, effect, b_effect, n_effect, height;

  v_clrwk (handle);
  vst_color (handle,BLACK);
  if (res == 0)
    height = 4;
  else
    height = 8;
  vst_height (handle,height,&dummy,&dummy,&dummy,&dummy);
  b_effect = 1;
  for (x=5*h_factor; x<260*h_factor; x+=62*h_factor) {
    n_effect = 1;
    for (y=25*v_factor; y<126*v_factor; y+=25*v_factor) {
      effect = b_effect | n_effect;
      vst_effects (handle,effect);
      v_gtext (handle,x,y,"EFFECTS");
      n_effect <<= 1;
    }
  b_effect <<= 1;
  }
}

/*******************************************************
* Text Rotation
*******************************************************/
do_rotate()
{
  int angle;

  v_clrwk (handle);
  vst_height (handle,8,&dummy,&dummy,&dummy,&dummy);
  for (angle=0; angle<2701; angle+=900) {
    vst_rotation (handle,angle);
    v_gtext (handle,160*h_factor,96*v_factor,"ROTATION");
  }
  vst_rotation (handle,0);
}

/*******************************************************
* Initialize Resolution Dependant Variables
*******************************************************/
init()
{
  int x;

  switch (res=Getrez) {
    case 0 :
      h_factor = 1;
      v_factor = 1;
      t_factor = 0;
      break;
    case 1 :
      h_factor = 2;
      v_factor = 1;
      t_factor = 1;
      break;
    case 2 :
      h_factor = 2;
      v_factor = 2;
      t_factor = 1;
  }
}

/*******************************************************
* Demonstrate Raster Operations
*******************************************************/
do_raster ()
{
   int button, x, y, repeat;

   v_clrwk (handle);
   graf_mouse (POINT_HAND, 0L);
   x = 50; y = 50;                       /* Initial location of icon.*/
   repeat = TRUE;
   while (repeat) {
      v_hide_c ( handle);
      draw_icon (icon,REPLACE,icn_w,icn_h,x,y);
      v_show_c (handle);
      button = 0;
      while (button == 0)
         vq_mouse (handle,&button,&x,&y); /* Get mouse status.        */
      if (button == RIGHT) 
         repeat = FALSE;
   }
}

/*******************************************************
* Perform Raster Operations
*******************************************************/
draw_icon (data,mode,width,height,dx,dy)
long data[];
int mode,   /* Raster writing mode.  */
    width,  /* Icon width.           */
    height, /* Icon height.          */
    dx,    /* Upper left X coordinate of destination rectangle.  */
    dy;    /* Upper left Y coordinate of destination rectangle.  */
{
   MFDB s_m,   /* Form definition block for source.                  */
        scr_m; /* Form definition block for screen.                  */
   int pxy[8];

   s_m.fd_addr = (long) data;          /* Store addr of icon data in MFDB. */
   s_m.fd_w = width;                   /* Store width of icon in MFDB.     */
   s_m.fd_h = height;                  /* Store height of icon in MFDB.    */
   s_m.fd_wdwidth = width/16;          /* Store icon width/16 in MFDB.     */
   s_m.fd_stand = 0;                   /* Raster coordinates.              */
   s_m.fd_nplanes = 4;                 /* Low resolution (4 bit planes).   */
   s_m.fd_r1 = s_m.fd_r2 = s_m.fd_r3 = 0;/* Zero out reserved words.         */
   scr_m.fd_addr = 0;                  /* Set up screen MFDB.              */
   pxy[0] = 0;           /* Upper left X coord of source block.       */
   pxy[1] = 0;           /* Upper left Y coord of source block.       */
   pxy[2] = width-1;     /* Lower right X coord of source block.      */
   pxy[3] = height-1;    /* Lower right Y coord of source block.      */
   pxy[4] = dx;          /* Upper left X coord of destination block.  */
   pxy[5] = dy;          /* Upper left Y coord of destination block.  */
   pxy[6] = dx+width-1;  /* Lower right X coord of destination block. */
   pxy[7] = dy+height-1; /* Lower right Y coord of destination block. */
   vro_cpyfm(handle,mode,pxy,&s_m,&scr_m); /* Do the raster operation. */
}

open_vwork()
{
  int i;

  for (i=0; i<10; work_in[i++] = 1);
  work_in[10] = 2;
  handle = graf_handle(&cellw, &cellh, &boxw, &boxh);
  v_opnvwk(work_in, &handle, work_out);
}

